%This matlab script will interpret a directory of .py output files from the 
%AQP simulator with a single experimental condition, outputting the ADC vs Delta 
%vector into a .mat file. 

%Written by Hunter Cole Davis, Caltech (hdavis AT caltech DOT edu)
%Citation: Mukherjee, A., Wu D, Davis HC, Shapiro MG. Non-invasive imaging using reporter genes altering cellular water permeability. Nat. Commun. 7, 13891 doi: 10.1038/ncomms13891 (2016).


ADC=zeros(1,400);%Adjust array size to (1,t) for t time steps. 
parpool(16)
samplestocheck=[0,5,11,22,43,65,97,108];


xdir=dir(fullfile('your_file_directory_location_goes_here')));
sumsq=textread('first_output_python_file_in_your_directory_goes_here');

for i=2:size(xdir,1)/3
a=load(fullfile('your_directory_location',xdir(i).name));
sumsq=horzcat(sumsq,a);
end
syms b
parfor p=2:400
ADC(p)=-limit(log(mean(exp(-b^2*sumsq(p,:)/2),2))./(b^2*(p-1)),b,0,'right');
end
save('save_file_name','ADC','-v7.3')

delete(gcp)
